/*! \mainpage Task Description
 *
 * Follow the instructions below.
 *
 * @file
 */

#include "solution.hpp"

/**
 * Use std::accumulate to calculate the sum of those array elements
 * whose value is less than a given threshold.
 * Supply a lambda expression as a binary operation to std::accumulate.
 * @param numbers an array of 10 integers
 * @return the sum of elements in question
 */
int sum1(const std::array<int, 10> numbers, const int threshold) {
    return 0;
}

/**
 * Use std::accumulate to concatenate string elements of a given array,
 * only those that are shorter than a given threshold.
 * Supply a lambda expression as an argument to std::accumulate.
 * @param fruits an array of 5 strings.
 * @param threshold the maximal admissible length of the string to be considered for concatenation.
 * @return the contatenated string consisting of all elements that were concatenated.
 */
std::string sum2(std::array<std::string, 5> fruits, size_t threshold) {
    return std::string{};
}

/**
 * Use std::sort to sort an array of strings in lexicographical order.
 * Supply a lambda expression to std::sort.
 * @param fruits an array to sort.
 */
void sort1(std::array<std::string, 5> &fruits) {}

/**
 * Use std::sort to sort an array of strings in reverse-lexicographical order.
 * Use the same lambda expression as in sort1.
 * Use std::bind() to remap the inputs of the lambda expression.
 * @param fruits an array to sort.
 */
void sort2(std::array<std::string, 5> &fruits) {
    auto lambda = [](const std::string& s1, const std::string& s2) {}

/**
 * Write a function getLambda which returns a lambda expression as described below.
 * Hint: use std::function<T> to store a lambda.
 * @return a lambda expression which takes two integers as numbers and returns their difference (first argument - second argument).
 * NOTICE! Do not forget to add a declaration of this function to solution.hpp file.
 */



